#!/usr/local/bin/perl
##############################################################################
# TCg}bvCGI Professional Ver1.0 iTCg}bv\pj
# Copyright(C) futomi 2001 - 2003
# http://www.futomi.com/
##############################################################################
use strict;
use CGI;
require './jcode.pl';
$| = 1;

### O[oϐ` #######################################################
my $q = new CGI;

my $TITLE = 'TCg}bv CGI Professional ';
my $COPYRIGHT = '<a href="http://www.futomi.com/" target="_blank">futomi\'s CGI Cafe</a>';
my $DATA_DIR = './data';
my $CONFG_DATA = './data/config.cgi';
my $HEADR_DATA = './data/header.cgi';
my $FOOTR_DATA = './data/footer.cgi';
#ݒf[^擾
my %CONF = &GetConf($CONFG_DATA);

#tHgTCYiptj
my $FONT_SIZE = '12';
#ZXy[VO
my $CELLSPACING = '5';
#ZpbfBO
my $CELLPADDING = '5';

my $FREE_SERVER_NAME = '\.tok2\.com';

### C[` ###########################################################

#t@[擾
my $referer = $ENV{'HTTP_REFERER'};
my $referer_arg = $q->param('url');
if($referer_arg) {
	$referer = $referer_arg;
}

#wb_[HTML擾
my $header = &ReadTemplate($HEADR_DATA);
#tb^[HTML擾
my $footer = &ReadTemplate($FOOTR_DATA);
#TCg}bvc[HTML쐬
my $sitemap;
if($CONF{'DISP'} eq '1') {		#}Xڂɂ킹
	$sitemap = &GetSitemapHtml1;
} else {						#ɋl߂
	$sitemap = &GetSitemapHtml2;
}

#o͗pHTML쐬
my $html;
$html .= "$header\n";
$html .= "$sitemap\n";
$html .= "$footer\n";

#TCg}bvHTMLo
print $q->header(-type=>'text/html; charset=Shift_JIS');
print "$html\n";
exit;


### Tu[` #############################################################

sub GetSitemapHtml2 {
	my $html;
	$html .= "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n";
	$html .= "  <tr>\n";
	for(my $c=1;$c<=$CONF{'COL'};$c++) {
		$html .= "    <td valign=\"top\">\n";
		$html .= "      <table border=\"0\" cellspacing=\"$CELLSPACING\" cellpadding=\"$CELLPADDING\">\n";
		for(my $r=1;$r<=$CONF{'ROW'};$r++) {
			$html .= "        <tr>\n";
			$html .= "          <td>\n";
			$html .= &GetTreeHtml($c, $r);
			$html .= "          </td>\n";
			$html .= "        </tr>\n";
		}
		$html .= "      </table>\n";
		$html .= "    </td>\n";
	}
	$html .= "  </tr>\n";
	$html .= "</table>\n";
	return $html;
}

sub GetSitemapHtml1 {
	my $html;
	$html .= "<table border=\"0\" cellspacing=\"$CELLSPACING\" cellpadding=\"$CELLPADDING\">\n";
	for(my $r=1;$r<=$CONF{'ROW'};$r++) {
		$html .= "  <tr>\n";
		for(my $c=1;$c<=$CONF{'COL'};$c++) {
			$html .= "  <td valign=\"top\">\n";
			$html .= &GetTreeHtml($c, $r);
			$html .= "  </td>\n";
		}
		$html .= "  </tr>\n";
	}
	$html .= "</table>\n";
	return $html;
}

sub GetNextId {
	my($id) = @_;
	my @parts = split(/\-/, $id);
	my $last_part = pop @parts;
	$last_part =~ s/^0+//;
	$last_part ++;
	$last_part = sprintf("%03d", $last_part);
	my $next_id = join('-', @parts);
	$next_id .= "\-$last_part";
	return $next_id;
}

sub MakeLineMark {
	my($id, $data_ref) = @_;
	my $img_folder = "<img src=\"$CONF{'IMAGE_DIR'}/theme/$CONF{'THEME'}/folder.gif\" width=\"18\" height=\"18\">";
	my $img_file   = "<img src=\"$CONF{'IMAGE_DIR'}/theme/$CONF{'THEME'}/file.gif\" width=\"18\" height=\"18\">";
	my $img_space  = "<img src=\"$CONF{'IMAGE_DIR'}/theme/$CONF{'THEME'}/space.gif\" width=\"18\" height=\"18\">";
	my $img_vline  = "<img src=\"$CONF{'IMAGE_DIR'}/theme/$CONF{'THEME'}/vline.gif\" width=\"18\" height=\"18\">";	# 
	my $img_joint1 = "<img src=\"$CONF{'IMAGE_DIR'}/theme/$CONF{'THEME'}/joint1.gif\" width=\"18\" height=\"18\">";	# it@Cpj
	my $img_joint2 = "<img src=\"$CONF{'IMAGE_DIR'}/theme/$CONF{'THEME'}/joint2.gif\" width=\"18\" height=\"18\">";	# itH_[pj
	my $img_joint3 = "<img src=\"$CONF{'IMAGE_DIR'}/theme/$CONF{'THEME'}/joint3.gif\" width=\"18\" height=\"18\">";	# it@Cpj
	my $img_joint4 = "<img src=\"$CONF{'IMAGE_DIR'}/theme/$CONF{'THEME'}/joint4.gif\" width=\"18\" height=\"18\">";	# itH_[pj
	my @id_parts = split(/\-/, $id);
	my $depth = scalar @id_parts;
	my $tmp_id;
	my $line_mark;
	$line_mark .= "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n";
	$line_mark .= "  <tr>\n";
	for(my $i=0;$i<$depth-1;$i++) {
		if($i) {$tmp_id .= '-';}
		$tmp_id .= $id_parts[$i];
		my $next_id = &GetNextId($tmp_id);
		if(exists $$data_ref{$next_id}) {
			$line_mark .= "    <td>$img_vline</td>\n";
		} else {
			$line_mark .= "    <td>$img_space</td>\n";
		}
	}
	my $next_id = &GetNextId($id);
	if(exists $$data_ref{$next_id}) {
		if(exists $$data_ref{"$id\-001"}) {
			$line_mark .= "    <td>$img_joint2</td>\n";
		} else {
			$line_mark .= "    <td>$img_joint1</td>\n";
		}
	} else {
		if(exists $$data_ref{"$id\-001"}) {
			$line_mark .= "    <td>$img_joint4</td>\n";
		} else {
			$line_mark .= "    <td>$img_joint3</td>\n";
		}
	}
	if(exists $$data_ref{"$id\-001"}) {
		$line_mark .= "    <td>$img_folder</td>\n";
	} else {
		$line_mark .= "    <td>$img_file</td>\n";
	}
	$line_mark .= "  </tr>\n";
	$line_mark .= "</table>\n";
	return $line_mark;
}

sub GetTreeHtml {
	my($col, $row) = @_;
	my %data = &GetLinkData($col, $row);
	my $target = '';
	if($CONF{'TARGET_SELECT'} eq '1') {
		$target = ' target="_self"';
	} elsif($CONF{'TARGET_SELECT'} eq '2') {
		$target = ' target="_top"';
	} elsif($CONF{'TARGET_SELECT'} eq '3') {
		$target = ' target="_blank"';
	} elsif($CONF{'TARGET_SELECT'} eq '4') {
		$target = ' target="_parent"';
	} elsif($CONF{'TARGET_SELECT'} eq '99') {
		$target = " target=\"$CONF{'TARGET'}\"";
	}

	my $marker;
	if($CONF{'MARKER'}) {
		$marker = "&nbsp;<img src=\"$CONF{'IMAGE_DIR'}/marker/$CONF{'MARKER'}\.gif\" border=\"0\">";
	} else {
		$marker = $CONF{'HERE_STR'};
	}

	my $referer = $ENV{'HTTP_REFERER'};
	my $url = $q->param('url');
	if($url) {
		$referer = $url;
	}

	my @indexes = split(/\t/, $CONF{'DIRECTORYINDEX'});
	my @referer_parts = split(/\//, $referer);
	my $referer_last_part = '';
	my $parts_num = scalar @referer_parts;
	if($parts_num >= 4) {
		$referer_last_part = pop @referer_parts;
	}
	my $form;
	$form .= "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"$CONF{'WIDTH'}\">\n";
	for my $id (sort keys %data) {
		$form .= "  <tr>\n";
		$form .= "    <td>\n";
		$form .= "      <table border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr>\n";
		$form .= "        <td>\n";
		my $line_mark = &MakeLineMark($id, \%data);
		my($title, $url) = split(/\t/, $data{$id});
		if($CONF{'FOLD'} eq '3' && length($title) > $CONF{'WRAP'}) {
			$title = &WordWrap($title, $CONF{'WRAP'});
			$title .= '...';
		}
		$title = &SecureHtml($title);
		$form .= "$line_mark\n";
		$form .= "        </td>\n";
		if($CONF{'FOLD'} eq '2') {
			$form .= "        <td nowrap>\n";
		} else {
			$form .= "        <td>\n";
		}
		if($url eq '' || $url !~ /^https*:\/\/.+$/) {
			$form .= "          &nbsp;<span style=\"font-size:12px;vertical-align:middle;\">$title</span>\n";
		} else {
			$form .= "          &nbsp;<a href=\"$url\" style=\"font-size:12px;vertical-align:middle;\"$target>$title</a>";
			my $flag = 0;
			if($referer_last_part eq '') {
				for my $index (@indexes) {
					my $tmp = $referer;
					$tmp =~ s/\/$//;
					$tmp .= "\/$index";
					if($url eq $tmp) {
						$flag = 1;
						last;
					}
				}
			} else {
				if($url eq $referer) {
					$flag = 1;
				}
			}
			if($flag) {
				$form .= "$marker";
			}
			$form .= "\n";
		}
		$form .= "        </td>\n";
		$form .= "      </tr></table>\n";
		$form .= "    </td>\n";
		$form .= "  </tr>\n";
	}
	$form .= "</table>\n";
	return $form;
}

sub GetLinkData {
	my($col, $row) = @_;
	$col = sprintf("%03d", $col);
	$row = sprintf("%03d", $row);
	my $file = "$DATA_DIR/${col}-${row}.cgi";
	my %data;
	if(open(LINK, "$file")) {
		while(<LINK>) {
			chop;
			my @parts = split(/\t/);
			my $id = shift @parts;
			my $value = join("\t", @parts);
			$data{$id} = $value;
		}
		close(LINK);
	}
	return %data;
}

sub ReadTemplate {
	my($file) = @_;
	unless(-e $file) {
		&ErrorPrint("ev[gt@C $file ܂B: $!");
	}
	my $size = -s $file;
	if(!open(FILE, "$file")) {
		&ErrorPrint("ev[gt@C <tt>$file</tt> I[vł܂łB : $!");
		exit;
	}
	binmode(FILE);
	my $html;
	sysread(FILE, $html, $size);
	close(FILE);
	$html =~ s/\$TITLE\$/$TITLE/g;
	$html =~ s/\$COPYRIGHT\$/$COPYRIGHT/g;
	return $html;
}

sub SecureHtml {
	my($html) = @_;
	$html =~ s/\&amp;/\&/g;
	$html =~ s/\&/&amp;/g;
	$html =~ s/\"/&quot;/g;
	$html =~ s/</&lt;/g;
	$html =~ s/>/&gt;/g;
	return $html;
}

sub GetConf {
	my($file) = @_;
	my %data = ();
	open(FILE, "$file") || &ErrorPrint("ݒt@C <tt>$file</tt> I[vł܂łB: $!");
	while(<FILE>) {
		chop;
		if(/^([a-zA-Z0-9\_\-]+)\=(.+)$/) {
			my $key = $1;
			my $value = $2;
			unless($key) {next;}
			$key =~ s/^[\s\t]*//;
			$key =~ s/[\s\t]*$//;
			$value =~ s/^[\s\t]*//;
			$value =~ s/[\s\t]*$//;
			$data{$key} = $value;
		}
	}
	close(FILE);
	return %data;
}

sub WordWrap {
	my($Str, $WRAP) = @_;
	&jcode::convert(\$Str, 'euc');

	my $WrapedStr = '';
	my $LineLength = 0;
	my($word, $WordLength);
	my(@SplitedWords, $buff, $byte, $i, @Words, @WordParts, $part);
	my @Lines = split(/\n/, $Str);
	my $line;
	my $KanjiFlag = 0;
	my $KanjiFirstByteFlag = 1;
	for $line (@Lines) {
		@Words = split(/ /, $line);
		for $word (@Words) {
			@WordParts = ();
			$i = 0;
			$KanjiFirstByteFlag = 1;
			$part = '';
			while($i <= length($word) - 1) {
				$byte = substr($word, $i, 1);
				if($byte =~ /[\x8E\xA1-\xFE]/) {	#{
					unless($KanjiFlag) {
						push(@WordParts, $part);
						$part = '';
						$KanjiFirstByteFlag = 1;
						$KanjiFlag = 1;
					}
					$part .= "$byte";
					if($KanjiFirstByteFlag) {
						$KanjiFirstByteFlag = 0;
					} else {
						$KanjiFirstByteFlag = 1;
						push(@WordParts, $part);
						$part = '';
					}
				} else {				#p
					if($KanjiFlag) {
						$part = '';
					}
					$part .= "$byte";
					if($byte =~ /^(\-|\/)$/) {
						push(@WordParts, $part);
						$part = '';
					}
					$KanjiFlag = 0;
					$KanjiFirstByteFlag = 1;
				}
				$i ++;
			}
			push(@WordParts, $part);
			for $part (@WordParts) {
				if($LineLength + length($part) > $WRAP) {
					$WrapedStr .= "\n";
					$LineLength = 0;
				}
				$WrapedStr .= "$part";
				$LineLength += length($part);
			}
			$WrapedStr .= " ";
			$LineLength += 1;
		}
		$WrapedStr .= "\n";
		$LineLength = 0;
	}
	my($line) = split(/\n/, $WrapedStr);
	&jcode::convert(\$line, 'sjis');
	return $line;
}

sub ErrorPrint {
	my($msg) = @_;
	select(STDOUT);
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print "$msg\n";
	exit;
}

